﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;
using Outlook = Microsoft.Office.Interop.Outlook;

namespace ADXSolutionsModule
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("2D640EAB-A369-4B63-A378-C99663469DDF"), ProgId("ADXSolutionsModule.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private ADXOLSolutionModule adxolSolutionModule1;
        public AddinExpress.OL.ADXOlFormsManager adxOlFormsManager1;
        private ADXRibbonTab adxRibbonTab1;
        private ADXRibbonGroup adxRibbonGroup1;
        private ADXRibbonButton adxRibbonButton1;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxolSolutionModule1 = new AddinExpress.MSO.ADXOLSolutionModule(this.components);
            this.adxOlFormsManager1 = new AddinExpress.OL.ADXOlFormsManager(this.components);
            this.adxRibbonTab1 = new AddinExpress.MSO.ADXRibbonTab(this.components);
            this.adxRibbonGroup1 = new AddinExpress.MSO.ADXRibbonGroup(this.components);
            this.adxRibbonButton1 = new AddinExpress.MSO.ADXRibbonButton(this.components);
            this.adxOlFormsManager1.SetOwner(this);
            // 
            // adxRibbonTab1
            // 
            this.adxRibbonTab1.Caption = "adxRibbonTab1";
            this.adxRibbonTab1.Controls.Add(this.adxRibbonGroup1);
            this.adxRibbonTab1.Id = "adxRibbonTab_e2a355dd91f14b36bd57e0917bb56ed5";
            this.adxRibbonTab1.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // adxRibbonGroup1
            // 
            this.adxRibbonGroup1.Caption = "adxRibbonGroup1";
            this.adxRibbonGroup1.Controls.Add(this.adxRibbonButton1);
            this.adxRibbonGroup1.Id = "adxRibbonGroup_e26501c023c44e73a2e67d2a2a7736cd";
            this.adxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            // 
            // adxRibbonButton1
            // 
            this.adxRibbonButton1.Caption = "adxRibbonButton1";
            this.adxRibbonButton1.Id = "adxRibbonButton_beaedf6bec954ed98c97403824f9b8b2";
            this.adxRibbonButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxRibbonButton1.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookExplorer;
            this.adxRibbonButton1.OnClick += new AddinExpress.MSO.ADXRibbonOnAction_EventHandler(this.adxRibbonButton1_OnClick);
            // 
            // AddinModule
            // 
            this.AddinName = "ADXSolutionsModule";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;
            this.AddinStartupComplete += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinStartupComplete);

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        private void AddinModule_AddinStartupComplete(object sender, EventArgs e)
        {
            // Root Folder - Northwind
            ADXOLSolutionFolder rootFolder = new ADXOLSolutionFolder();
            rootFolder.FolderName = "Northwind";
            rootFolder.FolderType = ADXOLSolutionFolderType.Notes;

            // Child Folder - Sales
            ADXOLSolutionFolder salesFolder = new ADXOLSolutionFolder();
            salesFolder.FolderName = "Sales";
            salesFolder.FolderType = ADXOLSolutionFolderType.Notes;

            // Sales Folder - Child Folders
            ADXOLSolutionFolder customersFolder = new ADXOLSolutionFolder();
            customersFolder.FolderName = "Customers";
            customersFolder.FolderType = ADXOLSolutionFolderType.Notes;

            // Contacts Folder - Child Folders
            ADXOLSolutionFolder contactsFolder = new ADXOLSolutionFolder();
            contactsFolder.FolderName = "Contacts";
            contactsFolder.FolderType = ADXOLSolutionFolderType.Contacts;

            // Orders Folder - Child Folders
            ADXOLSolutionFolder ordersFolder = new ADXOLSolutionFolder();
            ordersFolder.FolderName = "Orders";
            ordersFolder.FolderType = ADXOLSolutionFolderType.Notes;

            // Add Sub-folders to Sales Folder
            salesFolder.Folders.Add(customersFolder);
            salesFolder.Folders.Add(contactsFolder);
            salesFolder.Folders.Add(ordersFolder);

            // Add Sales folder to Root Folder
            rootFolder.Folders.Add(salesFolder);

            // Add Root Folder to the Solution Module component
            adxolSolutionModule1.Folders.Add(rootFolder);

            // Get the default sore name
            Outlook.NameSpace nameSpace = OutlookApp.GetNamespace("MAPI");
            Outlook.Store store = nameSpace.DefaultStore;
            string defaultStore = store.DisplayName;
            Marshal.ReleaseComObject(store);
            Marshal.ReleaseComObject(nameSpace);

            // Add item to Forms Manager Collection
            AddinExpress.OL.ADXOlFormsCollectionItem northwindFormItem = new AddinExpress.OL.ADXOlFormsCollectionItem();
            northwindFormItem.FormClassName = "ADXSolutionsModule.MyForm";            
            northwindFormItem.FolderName = defaultStore + "\\Northwind";
            adxOlFormsManager1.Items.Add(northwindFormItem);
            northwindFormItem.ExplorerLayout = AddinExpress.OL.ADXOlExplorerLayout.WebViewPane;

            AddinExpress.OL.ADXOlFormsCollectionItem contactsFormItem = new AddinExpress.OL.ADXOlFormsCollectionItem();
            contactsFormItem.FormClassName = "ADXSolutionsModule.MyForm";            
            contactsFormItem.FolderName = defaultStore + "\\Northwind\\Sales\\Contacts";
            adxOlFormsManager1.Items.Add(contactsFormItem);
            contactsFormItem.ExplorerLayout = AddinExpress.OL.ADXOlExplorerLayout.WebViewPane;
        }

        private void adxRibbonButton1_OnClick(object sender, IRibbonControl control, bool pressed)
        {
            adxOlFormsManager1.Items[0].FormClassName = "ADXSolutionsModule.AnotherForm";
            Outlook._Explorer activeExplorer = OutlookApp.ActiveExplorer();
            adxOlFormsManager1.Items[0].ApplyTo(activeExplorer);
            Marshal.ReleaseComObject(activeExplorer);
        }
    }
}

